ghc-8.2.2: The GHC API

Safe Haskell | None
Language | Haskell2010

RegAlloc.Linear.SPARC.FreeRegs

Description

Free regs map for SPARC

Synopsis

- data FreeRegs = FreeRegs !Word32 !Word32 !Word32
- noFreeRegs :: FreeRegs
- initFreeRegs :: Platform -> FreeRegs
- getFreeRegs :: RegClass -> FreeRegs -> [RealReg]
- allocateReg :: Platform -> RealReg -> FreeRegs -> FreeRegs
- releaseReg :: Platform -> RealReg -> FreeRegs -> FreeRegs
- bitMask :: Int -> Word32
- showFreeRegs :: FreeRegs -> String

# Documentation

data FreeRegs #

Constructors

FreeRegs !Word32 !Word32 !Word32 |

Instances

Show FreeRegs # |
Methods showsPrec :: Int -> FreeRegs -> ShowS Source # show :: FreeRegs -> String Source # showList :: [FreeRegs] -> ShowS Source #
FR FreeRegs # |
Methods frAllocateReg :: Platform -> RealReg -> FreeRegs -> FreeRegs # frGetFreeRegs :: Platform -> RegClass -> FreeRegs -> [RealReg] # frInitFreeRegs :: Platform -> FreeRegs # frReleaseReg :: Platform -> RealReg -> FreeRegs -> FreeRegs #

noFreeRegs :: FreeRegs #

A reg map where no regs are free to be allocated.

initFreeRegs :: Platform -> FreeRegs #

The initial set of free regs.

getFreeRegs :: RegClass -> FreeRegs -> [RealReg] #

Get all the free registers of this class.

allocateReg :: Platform -> RealReg -> FreeRegs -> FreeRegs #

Grab a register.

releaseReg :: Platform -> RealReg -> FreeRegs -> FreeRegs #

Release a register from allocation. The register liveness information says that most regs die after a C call, but we still don't want to allocate to some of them.

bitMask :: Int -> Word32 #

showFreeRegs :: FreeRegs -> String #